package ru.dbotthepony.kommons.test

import it.unimi.dsi.fastutil.io.FastByteArrayInputStream
import it.unimi.dsi.fastutil.io.FastByteArrayOutputStream
import org.junit.jupiter.api.Test
import ru.dbotthepony.kommons.io.readVarInt
import ru.dbotthepony.kommons.io.readVarIntInfo
import ru.dbotthepony.kommons.io.writeVarInt
import kotlin.test.assertEquals

object StreamTests {
	private fun readWrite(value: Int) {
		val output = FastByteArrayOutputStream()
		output.writeVarInt(value)
		val input = FastByteArrayInputStream(output.array, 0, output.length)
		val r = input.readVarIntInfo()
		assertEquals(value, r.value)
	}

	@Test
	fun varInts() {
		readWrite(0)
		readWrite(1)
		readWrite(2)
		readWrite(3)
		readWrite(63)
		readWrite(64)
		readWrite(65)
		readWrite(120)
		readWrite(121)
		readWrite(126)
		readWrite(127)
		readWrite(128)
		readWrite(129)
		readWrite(254)
		readWrite(255)
		readWrite(256)
	}
}